for (var global$1 = "undefined" != typeof global ? global : "undefined" != typeof self ? self : "undefined" != typeof window ? window : {}, isBrowser = "undefined" != typeof window && "undefined" != typeof document, longerTimeoutBrowsers = ["Edge", "Trident", "Firefox"], timeoutDuration = 0, i = 0; i < longerTimeoutBrowsers.length; i += 1)
    if (isBrowser && navigator.userAgent.indexOf(longerTimeoutBrowsers[i]) >= 0) {
        timeoutDuration = 1;
        break;
    }
function microtaskDebounce(e) { var t = !1; return function () { t || (t = !0, window.Promise.resolve().then(function () { t = !1, e(); })); }; }
function taskDebounce(e) { var t = !1; return function () { t || (t = !0, setTimeout(function () { t = !1, e(); }, timeoutDuration)); }; }
var supportsMicroTasks = isBrowser && window.Promise, debounce = supportsMicroTasks ? microtaskDebounce : taskDebounce;
function isFunction(e) { return e && "[object Function]" === {}.toString.call(e); }
function getStyleComputedProperty(e, t) { if (1 !== e.nodeType)
    return []; var n = getComputedStyle(e, null); return t ? n[t] : n; }
function getParentNode(e) { return "HTML" === e.nodeName ? e : e.parentNode || e.host; }
function getScrollParent(e) { if (!e)
    return document.body; switch (e.nodeName) {
    case "HTML":
    case "BODY": return e.ownerDocument.body;
    case "#document": return e.body;
} var t = getStyleComputedProperty(e), n = t.overflow, r = t.overflowX, o = t.overflowY; return /(auto|scroll|overlay)/.test(n + o + r) ? e : getScrollParent(getParentNode(e)); }
var cache = {}, isIE = function () { var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "all"; if (e = e.toString(), cache.hasOwnProperty(e))
    return cache[e]; switch (e) {
    case "11":
        cache[e] = -1 !== navigator.userAgent.indexOf("Trident");
        break;
    case "10":
        cache[e] = -1 !== navigator.appVersion.indexOf("MSIE 10");
        break;
    case "all": cache[e] = -1 !== navigator.userAgent.indexOf("Trident") || -1 !== navigator.userAgent.indexOf("MSIE");
} return cache.all = cache.all || Object.keys(cache).some(function (e) { return cache[e]; }), cache[e]; };
function getOffsetParent(e) { if (!e)
    return document.documentElement; for (var t = isIE(10) ? document.body : null, n = e.offsetParent; n === t && e.nextElementSibling;)
    n = (e = e.nextElementSibling).offsetParent; var r = n && n.nodeName; return r && "BODY" !== r && "HTML" !== r ? -1 !== ["TD", "TABLE"].indexOf(n.nodeName) && "static" === getStyleComputedProperty(n, "position") ? getOffsetParent(n) : n : e ? e.ownerDocument.documentElement : document.documentElement; }
function isOffsetContainer(e) { var t = e.nodeName; return "BODY" !== t && ("HTML" === t || getOffsetParent(e.firstElementChild) === e); }
function getRoot(e) { return null !== e.parentNode ? getRoot(e.parentNode) : e; }
function findCommonOffsetParent(e, t) { if (!(e && e.nodeType && t && t.nodeType))
    return document.documentElement; var n = e.compareDocumentPosition(t) & Node.DOCUMENT_POSITION_FOLLOWING, r = n ? e : t, o = n ? t : e, i = document.createRange(); i.setStart(r, 0), i.setEnd(o, 0); var s = i.commonAncestorContainer; if (e !== s && t !== s || r.contains(o))
    return isOffsetContainer(s) ? s : getOffsetParent(s); var a = getRoot(e); return a.host ? findCommonOffsetParent(a.host, t) : findCommonOffsetParent(e, getRoot(t).host); }
function getScroll(e) { var t = "top" === (arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "top") ? "scrollTop" : "scrollLeft", n = e.nodeName; if ("BODY" === n || "HTML" === n) {
    var r = e.ownerDocument.documentElement;
    return (e.ownerDocument.scrollingElement || r)[t];
} return e[t]; }
function includeScroll(e, t) { var n = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], r = getScroll(t, "top"), o = getScroll(t, "left"), i = n ? -1 : 1; return e.top += r * i, e.bottom += r * i, e.left += o * i, e.right += o * i, e; }
function getBordersSize(e, t) { var n = "x" === t ? "Left" : "Top", r = "Left" === n ? "Right" : "Bottom"; return parseFloat(e["border" + n + "Width"], 10) + parseFloat(e["border" + r + "Width"], 10); }
function getSize(e, t, n, r) { return Math.max(t["offset" + e], t["scroll" + e], n["client" + e], n["offset" + e], n["scroll" + e], isIE(10) ? n["offset" + e] + r["margin" + ("Height" === e ? "Top" : "Left")] + r["margin" + ("Height" === e ? "Bottom" : "Right")] : 0); }
function getWindowSizes() { var e = document.body, t = document.documentElement, n = isIE(10) && getComputedStyle(t); return { height: getSize("Height", e, t, n), width: getSize("Width", e, t, n) }; }
var classCallCheck = function (e, t) { if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function"); }, createClass = function () { function e(e, t) { for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
} } return function (t, n, r) { return n && e(t.prototype, n), r && e(t, r), t; }; }(), defineProperty = function (e, t, n) { return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e; }, _extends = Object.assign || function (e) { for (var t = 1; t < arguments.length; t++) {
    var n = arguments[t];
    for (var r in n)
        Object.prototype.hasOwnProperty.call(n, r) && (e[r] = n[r]);
} return e; };
function getClientRect(e) { return _extends({}, e, { right: e.left + e.width, bottom: e.top + e.height }); }
function getBoundingClientRect(e) { var t = {}; try {
    if (isIE(10)) {
        t = e.getBoundingClientRect();
        var n = getScroll(e, "top"), r = getScroll(e, "left");
        t.top += n, t.left += r, t.bottom += n, t.right += r;
    }
    else
        t = e.getBoundingClientRect();
}
catch (e) { } var o = { left: t.left, top: t.top, width: t.right - t.left, height: t.bottom - t.top }, i = "HTML" === e.nodeName ? getWindowSizes() : {}, s = i.width || e.clientWidth || o.right - o.left, a = i.height || e.clientHeight || o.bottom - o.top, f = e.offsetWidth - s, l = e.offsetHeight - a; if (f || l) {
    var p = getStyleComputedProperty(e);
    f -= getBordersSize(p, "x"), l -= getBordersSize(p, "y"), o.width -= f, o.height -= l;
} return getClientRect(o); }
function getOffsetRectRelativeToArbitraryNode(e, t) { var n = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], r = isIE(10), o = "HTML" === t.nodeName, i = getBoundingClientRect(e), s = getBoundingClientRect(t), a = getScrollParent(e), f = getStyleComputedProperty(t), l = parseFloat(f.borderTopWidth, 10), p = parseFloat(f.borderLeftWidth, 10); n && "HTML" === t.nodeName && (s.top = Math.max(s.top, 0), s.left = Math.max(s.left, 0)); var d = getClientRect({ top: i.top - s.top - l, left: i.left - s.left - p, width: i.width, height: i.height }); if (d.marginTop = 0, d.marginLeft = 0, !r && o) {
    var c = parseFloat(f.marginTop, 10), u = parseFloat(f.marginLeft, 10);
    d.top -= l - c, d.bottom -= l - c, d.left -= p - u, d.right -= p - u, d.marginTop = c, d.marginLeft = u;
} return (r && !n ? t.contains(a) : t === a && "BODY" !== a.nodeName) && (d = includeScroll(d, t)), d; }
function getViewportOffsetRectRelativeToArtbitraryNode(e) { var t = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], n = e.ownerDocument.documentElement, r = getOffsetRectRelativeToArbitraryNode(e, n), o = Math.max(n.clientWidth, window.innerWidth || 0), i = Math.max(n.clientHeight, window.innerHeight || 0), s = t ? 0 : getScroll(n), a = t ? 0 : getScroll(n, "left"); return getClientRect({ top: s - r.top + r.marginTop, left: a - r.left + r.marginLeft, width: o, height: i }); }
function isFixed(e) { var t = e.nodeName; return "BODY" !== t && "HTML" !== t && ("fixed" === getStyleComputedProperty(e, "position") || isFixed(getParentNode(e))); }
function getFixedPositionOffsetParent(e) { if (!e || !e.parentElement || isIE())
    return document.documentElement; for (var t = e.parentElement; t && "none" === getStyleComputedProperty(t, "transform");)
    t = t.parentElement; return t || document.documentElement; }
function getBoundaries(e, t, n, r) { var o = arguments.length > 4 && void 0 !== arguments[4] && arguments[4], i = { top: 0, left: 0 }, s = o ? getFixedPositionOffsetParent(e) : findCommonOffsetParent(e, t); if ("viewport" === r)
    i = getViewportOffsetRectRelativeToArtbitraryNode(s, o);
else {
    var a = void 0;
    "scrollParent" === r ? "BODY" === (a = getScrollParent(getParentNode(t))).nodeName && (a = e.ownerDocument.documentElement) : a = "window" === r ? e.ownerDocument.documentElement : r;
    var f = getOffsetRectRelativeToArbitraryNode(a, s, o);
    if ("HTML" !== a.nodeName || isFixed(s))
        i = f;
    else {
        var l = getWindowSizes(), p = l.height, d = l.width;
        i.top += f.top - f.marginTop, i.bottom = p + f.top, i.left += f.left - f.marginLeft, i.right = d + f.left;
    }
} return i.left += n, i.top += n, i.right -= n, i.bottom -= n, i; }
function getArea(e) { return e.width * e.height; }
function computeAutoPlacement(e, t, n, r, o) { var i = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0; if (-1 === e.indexOf("auto"))
    return e; var s = getBoundaries(n, r, i, o), a = { top: { width: s.width, height: t.top - s.top }, right: { width: s.right - t.right, height: s.height }, bottom: { width: s.width, height: s.bottom - t.bottom }, left: { width: t.left - s.left, height: s.height } }, f = Object.keys(a).map(function (e) { return _extends({ key: e }, a[e], { area: getArea(a[e]) }); }).sort(function (e, t) { return t.area - e.area; }), l = f.filter(function (e) { var t = e.width, r = e.height; return t >= n.clientWidth && r >= n.clientHeight; }), p = l.length > 0 ? l[0].key : f[0].key, d = e.split("-")[1]; return p + (d ? "-" + d : ""); }
function getReferenceOffsets(e, t, n) { var r = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null; return getOffsetRectRelativeToArbitraryNode(n, r ? getFixedPositionOffsetParent(t) : findCommonOffsetParent(t, n), r); }
function getOuterSizes(e) { var t = getComputedStyle(e), n = parseFloat(t.marginTop) + parseFloat(t.marginBottom), r = parseFloat(t.marginLeft) + parseFloat(t.marginRight); return { width: e.offsetWidth + r, height: e.offsetHeight + n }; }
function getOppositePlacement(e) { var t = { left: "right", right: "left", bottom: "top", top: "bottom" }; return e.replace(/left|right|bottom|top/g, function (e) { return t[e]; }); }
function getPopperOffsets(e, t, n) { n = n.split("-")[0]; var r = getOuterSizes(e), o = { width: r.width, height: r.height }, i = -1 !== ["right", "left"].indexOf(n), s = i ? "top" : "left", a = i ? "left" : "top", f = i ? "height" : "width", l = i ? "width" : "height"; return o[s] = t[s] + t[f] / 2 - r[f] / 2, o[a] = n === a ? t[a] - r[l] : t[getOppositePlacement(a)], o; }
function find(e, t) { return Array.prototype.find ? e.find(t) : e.filter(t)[0]; }
function findIndex(e, t, n) { if (Array.prototype.findIndex)
    return e.findIndex(function (e) { return e[t] === n; }); var r = find(e, function (e) { return e[t] === n; }); return e.indexOf(r); }
function runModifiers(e, t, n) { return (void 0 === n ? e : e.slice(0, findIndex(e, "name", n))).forEach(function (e) { e.function && console.warn("`modifier.function` is deprecated, use `modifier.fn`!"); var n = e.function || e.fn; e.enabled && isFunction(n) && (t.offsets.popper = getClientRect(t.offsets.popper), t.offsets.reference = getClientRect(t.offsets.reference), t = n(t, e)); }), t; }
function update() { if (!this.state.isDestroyed) {
    var e = { instance: this, styles: {}, arrowStyles: {}, attributes: {}, flipped: !1, offsets: {} };
    e.offsets.reference = getReferenceOffsets(this.state, this.popper, this.reference, this.options.positionFixed), e.placement = computeAutoPlacement(this.options.placement, e.offsets.reference, this.popper, this.reference, this.options.modifiers.flip.boundariesElement, this.options.modifiers.flip.padding), e.originalPlacement = e.placement, e.positionFixed = this.options.positionFixed, e.offsets.popper = getPopperOffsets(this.popper, e.offsets.reference, e.placement), e.offsets.popper.position = this.options.positionFixed ? "fixed" : "absolute", e = runModifiers(this.modifiers, e), this.state.isCreated ? this.options.onUpdate(e) : (this.state.isCreated = !0, this.options.onCreate(e));
} }
function isModifierEnabled(e, t) { return e.some(function (e) { var n = e.name; return e.enabled && n === t; }); }
function getSupportedPropertyName(e) { for (var t = [!1, "ms", "Webkit", "Moz", "O"], n = e.charAt(0).toUpperCase() + e.slice(1), r = 0; r < t.length; r++) {
    var o = t[r], i = o ? "" + o + n : e;
    if (void 0 !== document.body.style[i])
        return i;
} return null; }
function destroy() { return this.state.isDestroyed = !0, isModifierEnabled(this.modifiers, "applyStyle") && (this.popper.removeAttribute("x-placement"), this.popper.style.position = "", this.popper.style.top = "", this.popper.style.left = "", this.popper.style.right = "", this.popper.style.bottom = "", this.popper.style.willChange = "", this.popper.style[getSupportedPropertyName("transform")] = ""), this.disableEventListeners(), this.options.removeOnDestroy && this.popper.parentNode.removeChild(this.popper), this; }
function getWindow(e) { var t = e.ownerDocument; return t ? t.defaultView : window; }
function attachToScrollParents(e, t, n, r) { var o = "BODY" === e.nodeName, i = o ? e.ownerDocument.defaultView : e; i.addEventListener(t, n, { passive: !0 }), o || attachToScrollParents(getScrollParent(i.parentNode), t, n, r), r.push(i); }
function setupEventListeners(e, t, n, r) { n.updateBound = r, getWindow(e).addEventListener("resize", n.updateBound, { passive: !0 }); var o = getScrollParent(e); return attachToScrollParents(o, "scroll", n.updateBound, n.scrollParents), n.scrollElement = o, n.eventsEnabled = !0, n; }
function enableEventListeners() { this.state.eventsEnabled || (this.state = setupEventListeners(this.reference, this.options, this.state, this.scheduleUpdate)); }
function removeEventListeners(e, t) { return getWindow(e).removeEventListener("resize", t.updateBound), t.scrollParents.forEach(function (e) { e.removeEventListener("scroll", t.updateBound); }), t.updateBound = null, t.scrollParents = [], t.scrollElement = null, t.eventsEnabled = !1, t; }
function disableEventListeners() { this.state.eventsEnabled && (cancelAnimationFrame(this.scheduleUpdate), this.state = removeEventListeners(this.reference, this.state)); }
function isNumeric(e) { return "" !== e && !isNaN(parseFloat(e)) && isFinite(e); }
function setStyles(e, t) { Object.keys(t).forEach(function (n) { var r = ""; -1 !== ["width", "height", "top", "right", "bottom", "left"].indexOf(n) && isNumeric(t[n]) && (r = "px"), e.style[n] = t[n] + r; }); }
function setAttributes(e, t) { Object.keys(t).forEach(function (n) { !1 !== t[n] ? e.setAttribute(n, t[n]) : e.removeAttribute(n); }); }
function applyStyle(e) { return setStyles(e.instance.popper, e.styles), setAttributes(e.instance.popper, e.attributes), e.arrowElement && Object.keys(e.arrowStyles).length && setStyles(e.arrowElement, e.arrowStyles), e; }
function applyStyleOnLoad(e, t, n, r, o) { var i = getReferenceOffsets(o, t, e, n.positionFixed), s = computeAutoPlacement(n.placement, i, t, e, n.modifiers.flip.boundariesElement, n.modifiers.flip.padding); return t.setAttribute("x-placement", s), setStyles(t, { position: n.positionFixed ? "fixed" : "absolute" }), n; }
function computeStyle(e, t) { var n = t.x, r = t.y, o = e.offsets.popper, i = find(e.instance.modifiers, function (e) { return "applyStyle" === e.name; }).gpuAcceleration; void 0 !== i && console.warn("WARNING: `gpuAcceleration` option moved to `computeStyle` modifier and will not be supported in future versions of Popper.js!"); var s, a, f = void 0 !== i ? i : t.gpuAcceleration, l = getBoundingClientRect(getOffsetParent(e.instance.popper)), p = { position: o.position }, d = { left: Math.floor(o.left), top: Math.floor(o.top), bottom: Math.floor(o.bottom), right: Math.floor(o.right) }, c = "bottom" === n ? "top" : "bottom", u = "right" === r ? "left" : "right", h = getSupportedPropertyName("transform"); if (a = "bottom" === c ? -l.height + d.bottom : d.top, s = "right" === u ? -l.width + d.right : d.left, f && h)
    p[h] = "translate3d(" + s + "px, " + a + "px, 0)", p[c] = 0, p[u] = 0, p.willChange = "transform";
else {
    var m = "bottom" === c ? -1 : 1, g = "right" === u ? -1 : 1;
    p[c] = a * m, p[u] = s * g, p.willChange = c + ", " + u;
} var v = { "x-placement": e.placement }; return e.attributes = _extends({}, v, e.attributes), e.styles = _extends({}, p, e.styles), e.arrowStyles = _extends({}, e.offsets.arrow, e.arrowStyles), e; }
function isModifierRequired(e, t, n) { var r = find(e, function (e) { return e.name === t; }), o = !!r && e.some(function (e) { return e.name === n && e.enabled && e.order < r.order; }); if (!o) {
    var i = "`" + t + "`", s = "`" + n + "`";
    console.warn(s + " modifier is required by " + i + " modifier in order to work, be sure to include it before " + i + "!");
} return o; }
function arrow(e, t) { var n; if (!isModifierRequired(e.instance.modifiers, "arrow", "keepTogether"))
    return e; var r = t.element; if ("string" == typeof r) {
    if (!(r = e.instance.popper.querySelector(r)))
        return e;
}
else if (!e.instance.popper.contains(r))
    return console.warn("WARNING: `arrow.element` must be child of its popper element!"), e; var o = e.placement.split("-")[0], i = e.offsets, s = i.popper, a = i.reference, f = -1 !== ["left", "right"].indexOf(o), l = f ? "height" : "width", p = f ? "Top" : "Left", d = p.toLowerCase(), c = f ? "left" : "top", u = f ? "bottom" : "right", h = getOuterSizes(r)[l]; a[u] - h < s[d] && (e.offsets.popper[d] -= s[d] - (a[u] - h)), a[d] + h > s[u] && (e.offsets.popper[d] += a[d] + h - s[u]), e.offsets.popper = getClientRect(e.offsets.popper); var m = a[d] + a[l] / 2 - h / 2, g = getStyleComputedProperty(e.instance.popper), v = parseFloat(g["margin" + p], 10), b = parseFloat(g["border" + p + "Width"], 10), y = m - e.offsets.popper[d] - v - b; return y = Math.max(Math.min(s[l] - h, y), 0), e.arrowElement = r, e.offsets.arrow = (defineProperty(n = {}, d, Math.round(y)), defineProperty(n, c, ""), n), e; }
function getOppositeVariation(e) { return "end" === e ? "start" : "start" === e ? "end" : e; }
var placements = ["auto-start", "auto", "auto-end", "top-start", "top", "top-end", "right-start", "right", "right-end", "bottom-end", "bottom", "bottom-start", "left-end", "left", "left-start"], validPlacements = placements.slice(3);
function clockwise(e) { var t = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], n = validPlacements.indexOf(e), r = validPlacements.slice(n + 1).concat(validPlacements.slice(0, n)); return t ? r.reverse() : r; }
var BEHAVIORS = { FLIP: "flip", CLOCKWISE: "clockwise", COUNTERCLOCKWISE: "counterclockwise" };
function flip(e, t) { if (isModifierEnabled(e.instance.modifiers, "inner"))
    return e; if (e.flipped && e.placement === e.originalPlacement)
    return e; var n = getBoundaries(e.instance.popper, e.instance.reference, t.padding, t.boundariesElement, e.positionFixed), r = e.placement.split("-")[0], o = getOppositePlacement(r), i = e.placement.split("-")[1] || "", s = []; switch (t.behavior) {
    case BEHAVIORS.FLIP:
        s = [r, o];
        break;
    case BEHAVIORS.CLOCKWISE:
        s = clockwise(r);
        break;
    case BEHAVIORS.COUNTERCLOCKWISE:
        s = clockwise(r, !0);
        break;
    default: s = t.behavior;
} return s.forEach(function (a, f) { if (r !== a || s.length === f + 1)
    return e; r = e.placement.split("-")[0], o = getOppositePlacement(r); var l = e.offsets.popper, p = e.offsets.reference, d = Math.floor, c = "left" === r && d(l.right) > d(p.left) || "right" === r && d(l.left) < d(p.right) || "top" === r && d(l.bottom) > d(p.top) || "bottom" === r && d(l.top) < d(p.bottom), u = d(l.left) < d(n.left), h = d(l.right) > d(n.right), m = d(l.top) < d(n.top), g = d(l.bottom) > d(n.bottom), v = "left" === r && u || "right" === r && h || "top" === r && m || "bottom" === r && g, b = -1 !== ["top", "bottom"].indexOf(r), y = !!t.flipVariations && (b && "start" === i && u || b && "end" === i && h || !b && "start" === i && m || !b && "end" === i && g); (c || v || y) && (e.flipped = !0, (c || v) && (r = s[f + 1]), y && (i = getOppositeVariation(i)), e.placement = r + (i ? "-" + i : ""), e.offsets.popper = _extends({}, e.offsets.popper, getPopperOffsets(e.instance.popper, e.offsets.reference, e.placement)), e = runModifiers(e.instance.modifiers, e, "flip")); }), e; }
function keepTogether(e) { var t = e.offsets, n = t.popper, r = t.reference, o = e.placement.split("-")[0], i = Math.floor, s = -1 !== ["top", "bottom"].indexOf(o), a = s ? "right" : "bottom", f = s ? "left" : "top", l = s ? "width" : "height"; return n[a] < i(r[f]) && (e.offsets.popper[f] = i(r[f]) - n[l]), n[f] > i(r[a]) && (e.offsets.popper[f] = i(r[a])), e; }
function toValue(e, t, n, r) { var o = e.match(/((?:\-|\+)?\d*\.?\d*)(.*)/), i = +o[1], s = o[2]; if (!i)
    return e; if (0 === s.indexOf("%")) {
    var a = void 0;
    switch (s) {
        case "%p":
            a = n;
            break;
        case "%":
        case "%r":
        default: a = r;
    }
    return getClientRect(a)[t] / 100 * i;
} return "vh" === s || "vw" === s ? ("vh" === s ? Math.max(document.documentElement.clientHeight, window.innerHeight || 0) : Math.max(document.documentElement.clientWidth, window.innerWidth || 0)) / 100 * i : i; }
function parseOffset(e, t, n, r) { var o = [0, 0], i = -1 !== ["right", "left"].indexOf(r), s = e.split(/(\+|\-)/).map(function (e) { return e.trim(); }), a = s.indexOf(find(s, function (e) { return -1 !== e.search(/,|\s/); })); s[a] && -1 === s[a].indexOf(",") && console.warn("Offsets separated by white space(s) are deprecated, use a comma (,) instead."); var f = /\s*,\s*|\s+/, l = -1 !== a ? [s.slice(0, a).concat([s[a].split(f)[0]]), [s[a].split(f)[1]].concat(s.slice(a + 1))] : [s]; return (l = l.map(function (e, r) { var o = (1 === r ? !i : i) ? "height" : "width", s = !1; return e.reduce(function (e, t) { return "" === e[e.length - 1] && -1 !== ["+", "-"].indexOf(t) ? (e[e.length - 1] = t, s = !0, e) : s ? (e[e.length - 1] += t, s = !1, e) : e.concat(t); }, []).map(function (e) { return toValue(e, o, t, n); }); })).forEach(function (e, t) { e.forEach(function (n, r) { isNumeric(n) && (o[t] += n * ("-" === e[r - 1] ? -1 : 1)); }); }), o; }
function offset(e, t) { var n, r = t.offset, o = e.placement, i = e.offsets, s = i.popper, a = i.reference, f = o.split("-")[0]; return n = isNumeric(+r) ? [+r, 0] : parseOffset(r, s, a, f), "left" === f ? (s.top += n[0], s.left -= n[1]) : "right" === f ? (s.top += n[0], s.left += n[1]) : "top" === f ? (s.left += n[0], s.top -= n[1]) : "bottom" === f && (s.left += n[0], s.top += n[1]), e.popper = s, e; }
function preventOverflow(e, t) { var n = t.boundariesElement || getOffsetParent(e.instance.popper); e.instance.reference === n && (n = getOffsetParent(n)); var r = getBoundaries(e.instance.popper, e.instance.reference, t.padding, n, e.positionFixed); t.boundaries = r; var o = t.priority, i = e.offsets.popper, s = { primary: function (e) { var n = i[e]; return i[e] < r[e] && !t.escapeWithReference && (n = Math.max(i[e], r[e])), defineProperty({}, e, n); }, secondary: function (e) { var n = "right" === e ? "left" : "top", o = i[n]; return i[e] > r[e] && !t.escapeWithReference && (o = Math.min(i[n], r[e] - ("right" === e ? i.width : i.height))), defineProperty({}, n, o); } }; return o.forEach(function (e) { var t = -1 !== ["left", "top"].indexOf(e) ? "primary" : "secondary"; i = _extends({}, i, s[t](e)); }), e.offsets.popper = i, e; }
function shift(e) { var t = e.placement, n = t.split("-")[0], r = t.split("-")[1]; if (r) {
    var o = e.offsets, i = o.reference, s = o.popper, a = -1 !== ["bottom", "top"].indexOf(n), f = a ? "left" : "top", l = a ? "width" : "height", p = { start: defineProperty({}, f, i[f]), end: defineProperty({}, f, i[f] + i[l] - s[l]) };
    e.offsets.popper = _extends({}, s, p[r]);
} return e; }
function hide(e) { if (!isModifierRequired(e.instance.modifiers, "hide", "preventOverflow"))
    return e; var t = e.offsets.reference, n = find(e.instance.modifiers, function (e) { return "preventOverflow" === e.name; }).boundaries; if (t.bottom < n.top || t.left > n.right || t.top > n.bottom || t.right < n.left) {
    if (!0 === e.hide)
        return e;
    e.hide = !0, e.attributes["x-out-of-boundaries"] = "";
}
else {
    if (!1 === e.hide)
        return e;
    e.hide = !1, e.attributes["x-out-of-boundaries"] = !1;
} return e; }
function inner(e) { var t = e.placement, n = t.split("-")[0], r = e.offsets, o = r.popper, i = r.reference, s = -1 !== ["left", "right"].indexOf(n), a = -1 === ["top", "left"].indexOf(n); return o[s ? "left" : "top"] = i[n] - (a ? o[s ? "width" : "height"] : 0), e.placement = getOppositePlacement(t), e.offsets.popper = getClientRect(o), e; }
var modifiers = { shift: { order: 100, enabled: !0, fn: shift }, offset: { order: 200, enabled: !0, fn: offset, offset: 0 }, preventOverflow: { order: 300, enabled: !0, fn: preventOverflow, priority: ["left", "right", "top", "bottom"], padding: 5, boundariesElement: "scrollParent" }, keepTogether: { order: 400, enabled: !0, fn: keepTogether }, arrow: { order: 500, enabled: !0, fn: arrow, element: "[x-arrow]" }, flip: { order: 600, enabled: !0, fn: flip, behavior: "flip", padding: 5, boundariesElement: "viewport" }, inner: { order: 700, enabled: !1, fn: inner }, hide: { order: 800, enabled: !0, fn: hide }, computeStyle: { order: 850, enabled: !0, fn: computeStyle, gpuAcceleration: !0, x: "bottom", y: "right" }, applyStyle: { order: 900, enabled: !0, fn: applyStyle, onLoad: applyStyleOnLoad, gpuAcceleration: void 0 } }, Defaults = { placement: "bottom", positionFixed: !1, eventsEnabled: !0, removeOnDestroy: !1, onCreate: function () { }, onUpdate: function () { }, modifiers: modifiers }, Popper = function () { function e(t, n) { var r = this, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {}; classCallCheck(this, e), this.scheduleUpdate = function () { return requestAnimationFrame(r.update); }, this.update = debounce(this.update.bind(this)), this.options = _extends({}, e.Defaults, o), this.state = { isDestroyed: !1, isCreated: !1, scrollParents: [] }, this.reference = t && t.jquery ? t[0] : t, this.popper = n && n.jquery ? n[0] : n, this.options.modifiers = {}, Object.keys(_extends({}, e.Defaults.modifiers, o.modifiers)).forEach(function (t) { r.options.modifiers[t] = _extends({}, e.Defaults.modifiers[t] || {}, o.modifiers ? o.modifiers[t] : {}); }), this.modifiers = Object.keys(this.options.modifiers).map(function (e) { return _extends({ name: e }, r.options.modifiers[e]); }).sort(function (e, t) { return e.order - t.order; }), this.modifiers.forEach(function (e) { e.enabled && isFunction(e.onLoad) && e.onLoad(r.reference, r.popper, r.options, e, r.state); }), this.update(); var i = this.options.eventsEnabled; i && this.enableEventListeners(), this.state.eventsEnabled = i; } return createClass(e, [{ key: "update", value: function () { return update.call(this); } }, { key: "destroy", value: function () { return destroy.call(this); } }, { key: "enableEventListeners", value: function () { return enableEventListeners.call(this); } }, { key: "disableEventListeners", value: function () { return disableEventListeners.call(this); } }]), e; }();
Popper.Utils = ("undefined" != typeof window ? window : global$1).PopperUtils, Popper.placements = placements, Popper.Defaults = Defaults;
export { Popper as a };
